/**
 * 
 */
package com.nonesole.log;

/**
 * @author JACK LEE
 * @version 1.0 - build on 2011-03-10
 */
public class EasyLogDemo {
	
	private Logger logger;
	
	public EasyLogDemo(){
		logger = new Logger();
		logInfo();
		logWarn();
		logError();
		logFatal();
		logDebug();
	}
	
	private void logInfo(){
		logger.newInfo()
			  .setSimpleFormat(true)
			  .setDescription("Hello world!")
			  .write();
	}
	
	private void logWarn(){
		logger.clear()
		  .newWarn()
		  .setSimpleFormat(false)
		  .setUser("Tom")
		  .setSource("login.jsp")
		  .setDescription("Wrong password.")
		  .write();
	}
	
	private void logError(){
		try {
			throw new Exception("Do you see this error?");
		} catch ( Exception e ) {
			logger.clear()
			  .newError()
			  .setSimpleFormat(false)
			  .setSource("EasyLogDemo.logError")
			  .setDescription(e.getMessage())
			  .write(e);
		}
	}
	
	private void logFatal(){
		String s1 = null;
		try {
			String[] s2 = s1.split("/");
		} catch ( Exception e ) {
			logger.clear()
			  .newFatal()
			  .setSimpleFormat(false)
			  .setCategory("system")
			  .setData("s1="+s1)
			  .setSource("EasyLogDemo.logFatal")
			  .setDescription(e.getMessage())
			  .write(e);
		}
	}
	
	private void logDebug(){
		String s1 = null;
		try {
			String[] s2 = s1.split("/");
		} catch ( Exception e ) {
			logger.clear()
			  .newDebug()
			  .setSimpleFormat(false)
			  .setCategory("system")
			  .setData("s1="+s1)
			  .setSource("EasyLogDemo.logDebug")
			  .setDescription(e.getMessage())
			  .write(e);
		}
	}
	
	public static void main(String[] args) {
		new EasyLogDemo();
	}

}
