/*
    Persistence v1.04 is a easy-use O-R and O-F frame which suit local software.   
    Copyright (C) 2009 www.nonesole.com Jack Lee

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */
package com.nonesole.persistence.file.catalog;


/**
 * CatalogEntry
 * @author JACK LEE
 * @version 1.0 - build in 2009-07-21
 */
public class CatalogEntry {

	private String className;
	private String fileName;
	private String id;
	
	/**
	 * Current object is whether or not valid.
	 * @return true - valid
	 * */
	public boolean isValid(){
		if ( null == className
				|| "".equals(className)
				|| null == fileName
				|| "".equals(fileName)
				|| null == id
				|| "".equals(id) ) 
			return false;
		return true;
	}
	
	/**
	 * Rewrite toString method
	 * @return String
	 * */
	public String toString(){
		return this.id;
	}
	
	/**
	 * Rewrite equals method
	 * @return true or false
	 * */
	public boolean equals(Object obj){
		if ( obj instanceof CatalogEntry ) {
			if ( obj.hashCode() == this.hashCode() ) {
				if ( this.toString().equals(((CatalogEntry)obj).toString()) )
					return true;
			} else
				return false;
		}
		return false;
	}
	
	/**
	 * Rewrite hashCode method
	 * @return int - primary key's hashCode
	 * */
	public int hashCode(){
		return id.hashCode();
	}
	
	/**
	 * @return the className
	 */
	public String getClassName() {
		return className;
	}
	/**
	 * @param className the className to set
	 */
	public void setClassName(String className) {
		this.className = className;
	}
	/**
	 * @return the fileName
	 */
	public String getFileName() {
		return fileName;
	}
	/**
	 * @param fileName the fileName to set
	 */
	public void setFileName(String fileName) {
		this.fileName = fileName;
	}
	/**
	 * @return the id
	 */
	public String getId() {
		return id;
	}
	/**
	 * @param id the id to set
	 */
	public void setId(String id) {
		this.id = id;
	}
	
	
	
}
