/*
    Persistence v1.05 is a easy-use O-R and O-F frame which suit local software.   
    Copyright (C) 2009 www.nonesole.com Jack Lee

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */
package com.nonesole.persistence.file.operation.first;

import java.lang.reflect.Field;
import java.net.URI;
import java.util.List;
import java.util.TreeMap;

import com.nonesole.persistence.exception.OperationsException;

/**
 * This class implements FileAction interface.It is Serialization Object Operation.
 * @author JACK LEE
 * @version 1.0 - build on 2010-10-30
 */
public class SingletonSeFileAction implements FileAction {
	
	private static SingletonSeFileAction db;
	private static SeFileAction action;
	static {
		action = new SeFileAction();
		db = new SingletonSeFileAction();
	}
	
	private SingletonSeFileAction(){}
	
	public static SingletonSeFileAction self(){
		return db;
	}

	public List<?> batchInsert(List<?> obj) throws OperationsException {
		return action.batchInsert(obj);
	}

	public List<?> batchUpdate(Object obj, Predicate p, boolean replaceObject)
			throws OperationsException {
		return action.batchUpdate(obj, p, replaceObject);
	}

	public int delete(Predicate p, Class<?> clazz) throws OperationsException {
		return action.delete(p, clazz);
	}

	public Object insert(Object obj) throws OperationsException {
		return action.insert(obj);
	}

	public List<?> query(Predicate p, Class<?> clazz)
			throws OperationsException {
		return action.query(p, clazz);
	}

	public FileAction setDBFolder(URI uri) throws OperationsException {
		return action.setDBFolder(uri);
	}

	public Object update(Object obj, Predicate<?> p, boolean replaceObject)
			throws OperationsException {
		return action.update(obj, p, replaceObject);
	}

	public TreeMap<?, ?> createIndex(String indexName, Class<?> clazz,
			Field field) throws OperationsException {
		return action.createIndex(indexName, clazz, field);
	}

	public TreeMap<?, ?> getIndex(Class<?> clazz, String indexName)
			throws OperationsException {
		return action.getIndex(clazz, indexName);
	}

	public boolean removeIndex(Class<?> clazz, String indexName)
			throws OperationsException {
		return action.removeIndex(clazz, indexName);
	}

	public SeFileAction setChildFolder(String childFolder) {
		return action.setChildFolder(childFolder);
	}
				
	
	
	
}
