/*
    Persistence v1.04 is a easy-use O-R and O-F frame which suit local software.   
    Copyright (C) 2009 www.nonesole.com Jack Lee

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */
package com.nonesole.persistence.file.txt;

import com.nonesole.persistence.exception.OperationsException;
import com.nonesole.persistence.file.AbstractFilesOperation;
import com.nonesole.persistence.file.IFileTransformer;
import com.nonesole.persistence.file.TransformerFactory;
import com.nonesole.persistence.tools.FileToolkit;

/**
 * Text object operation
 * @author JACK LEE
 * @version 1.0 - build in 209-07-26
 */
public class TXTOperation extends AbstractFilesOperation {

	private static final TXTOperation TO = new TXTOperation();
	
	private static IFileTransformer ift = null;
		
	static {
		try {
			ift = TransformerFactory
				.getInstance()
				.getFileTransformer(TransformerFactory.TXT_FILE);
		} catch (OperationsException e) {
			new OperationsException(
					"Getting file transformer is failure.",e.fillInStackTrace());
		}		
	}
	
	public static TXTOperation getInstance(){
		return TO;
	}

	protected String getExtendFileName(){
		return TransformerFactory.TXT_FILE_END;
	}
	
	protected void saveFile(String fullFilePath,Object obj) 
	throws OperationsException {
		FileToolkit.insertContentByRondomAccessFile(
				fullFilePath, (String)ift.getContent(obj));
	}
	
}
