/*
    Persistence v1.04 is a easy-use O-R and O-F frame which suit local software.   
    Copyright (C) 2009 www.nonesole.com Jack Lee

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */
package com.nonesole.persistence.sql.parser;

import java.util.Vector;

/**
 * O-R mapping
 * @author JACK LEE
 * @version 1.0 - build in 2009-07-14
 */
public class SqlConfigMapping {

	private String className;
	private String tableName;
	private Vector<String> primeryKey;
	
	/**
	 * Current object is whether or not valid. 
	 * @return true - valid
	 * */
	public boolean isValid(){
		if ( null == className 
				|| "".equals(className)
				|| null == tableName
				|| "".equals(tableName) ) 
			return false;
		return true;
	}
	
	/**
	 * Rewrite toString method 
	 * @return String
	 * */
	public String toString(){
		return new StringBuilder()
			.append(this.className)
			.append("/")
			.append(this.tableName)
			.toString();
	}
	
	/**
	 * Rewrite equals method 
	 * this place do not need rewrite hashCode method.
	 * @return true or false
	 * */
	public boolean equals(Object obj){
		if ( obj instanceof SqlConfigMapping ) {
			SqlConfigMapping cpp = (SqlConfigMapping)obj;
			if ( this.className.equals(cpp.getClassName()) 
					&& this.tableName == cpp.getTableName() )
				return true;
		}
		return false;
	}
	
	/**
	 * @return the className
	 */
	public String getClassName() {
		return className;
	}
	/**
	 * @param className the className to set
	 */
	public void setClassName(String className) {
		this.className = className;
	}
	/**
	 * @return the tableName
	 */
	public String getTableName() {
		return tableName;
	}
	/**
	 * @param tableName the tableName to set
	 */
	public void setTableName(String tableName) {
		this.tableName = tableName;
	}
	/**
	 * @return the primeryKey
	 */
	public Vector<String> getPrimeryKey() {
		return primeryKey;
	}
	/**
	 * @param primeryKey the primeryKey to set
	 */
	public void setPrimeryKey(Vector<String> primeryKey) {
		this.primeryKey = primeryKey;
	}
	
}
