/*
    Persistence v1.04 is a easy-use O-R and O-F frame which suit local software.   
    Copyright (C) 2009 www.nonesole.com Jack Lee

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */
package com.nonesole.persistence.tools;

import java.text.DecimalFormat;

/**
 * Format Tools
 * @author JACK LEE
 * @version 1.1 - modify in 2009-08-01 Delete all toXX() methods 
 * @version 1.0 - build in 2008-03-26
 * */
public class FormatToolkit {
	
	/**
	 * Check object whether null
	 * @param obj object
	 * @return true - means null
	 * */
	public final static boolean isNull(Object obj) {
		if(obj == null 
			|| "".equals(obj) )
			return true;
		return false;
	}
	
	/**
	 * Check parameter whether is a number
	 * @param obj Object
	 * @return true - parameter is a number
	 * */
	public final static boolean isNumber(Object obj) {
		if( !isNull(obj) )
			return String.valueOf(obj).matches("[\\d]+");
		return false;
	}
	
	/**
	 * Transform object to string
	 * @param obj Object needs transform
	 * @return String
	 * */
	public final static String transformToString(Object obj){
		if ( null == obj )
			return "";
		
		DecimalFormat df = new DecimalFormat("#.####");
		Class<?> fieldType = obj.getClass();
		String parameter = null;
		if ( String.class != fieldType ) {
			if ( obj instanceof Number ){
				parameter = df.format(obj);
			} else if ( boolean.class == fieldType || Boolean.class == fieldType
					|| Character.class == fieldType || char.class == fieldType ) {
				parameter = String.valueOf(obj);
			} else {
				parameter = obj.toString();
			}
		} else {
			parameter = obj.toString();
		}
		if ( parameter == null )
			parameter = "";
		
		return parameter;
	}	
	
}
